/* ===========================================================================
 * IBA CZ Confidential
 *
 * © Copyright IBA CZ 2009 ALL RIGHTS RESERVED
 * The source code for this program is not published or otherwise
 * divested of its trade secrets.
 *
 * =========================================================================== */ 

package eu.ibacz.pv230.simpleshop.backend.service.impl;

import eu.ibacz.pv230.simpleshop.backend.dto.BasketItemDTO;
import eu.ibacz.pv230.simpleshop.backend.dto.ProductDTO;
import eu.ibacz.pv230.simpleshop.backend.entity.BasketItem;
import eu.ibacz.pv230.simpleshop.backend.entity.Product;
import java.util.ArrayList;
import java.util.List;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.BeansException;

/**
 *
 * @author Rastislav Papp
 */
public class ConversionUtils {

    public static List<ProductDTO> productDTOs(List<Product> entityList) throws BeansException {
        List<ProductDTO> result = new ArrayList<ProductDTO>();
        if (entityList != null) {
            for (Product p : entityList) {
                result.add(productDTO(p));
            }
        }
        return result;
    }

    public static ProductDTO productDTO(Product p) throws BeansException {
        ProductDTO productDTO = new ProductDTO();
        BeanUtils.copyProperties(p, productDTO);
        return productDTO;
    }
    
    public static List<BasketItemDTO> basketItemDTOs(List<BasketItem> items) {
        List<BasketItemDTO> result = new ArrayList<BasketItemDTO>();
        if (items != null) {
            for (BasketItem item : items) {
                result.add(basketItemDTO(item));
            }
        }
        return result;
    }

    public static BasketItemDTO basketItemDTO(BasketItem item) {
        BasketItemDTO result = new BasketItemDTO();
        result.setAmount(item.getAmount());
        result.setId(item.getId());
        result.setProduct(productDTO(item.getProduct()));
        return result;
    }
    
}
